import type { createClient } from 'redis';


export function redisCacher(tmpPath: string, options: { client?: ReturnType<typeof createClient> }): Partial<FCOptions> {
    return {
        async getCache() {
            // make sure socket is connected
            try {
                await options.client?.connect();
            } catch { }


            return JSON.parse(
                options.client && await options.client.get(tmpPath) || "{}"
            )
        },
        onDataUpdate: async (ndata: any) => {
            // make sure socket is connected
            try {
                await options.client?.connect();
            } catch { }

            options.client && await options.client.set(tmpPath, JSON.stringify(ndata))
        },
    };
}