import type { Redis } from '@upstash/redis';


export function upstashCacher(tmpPath: string, options: { client?: Redis }): Partial<FCOptions> {
  return {
    async getCache() {
      return JSON.parse(
        options.client && await options.client.get(tmpPath) || "{}"
      )
    },
    onDataUpdate: async (ndata: any) => {
      options.client && await options.client.set(tmpPath, JSON.stringify(ndata))
    },
  };
}